import { world,system,ItemStack} from "@minecraft/server"

world.afterEvents.entityDie.subscribe(({deadEntity}) => {
    try {
    const position = deadEntity.location
    const dimension = deadEntity.dimension
    if (deadEntity.typeId === 'edx:abomination2') {
        dimension.runCommand(`scoreboard players add * difficulty 1`)
        dimension.runCommand(`particle edx:abomination_death ${position.x} ${position.y} ${position.z}`)
        const entityOptions = {
            location: position,
            families: [ "player" ],
            maxDistance: 50
        }
        const entities = dimension.getEntities(entityOptions);
        for (let i = 0; i < entities.length ; i++){
            var chance = Math.random()
            if(chance<0.5)   
                dimension.spawnItem(new ItemStack('edx:xp_orb', 1), entities[i].location);
            else
                dimension.spawnItem(new ItemStack('edx:magic_axe', 1), entities[i].location);
            entities[i].runCommand(`scoreboard players add @s[tag=!abom] max_health 4`)
            entities[i].addTag('abom')

        }
    }
    //wither is in after hit bc of his anim
    if (deadEntity.typeId === 'minecraft:ender_dragon') {
        dimension.runCommand(`scoreboard players add * difficulty2 1`)
        const entityOptions = {
            location: position,
            families: [ "player" ],
            maxDistance: 100
        }
        const entities = dimension.getEntities(entityOptions);
        for (let i = 0; i < entities.length ; i++){
            entities[i].runCommand(`scoreboard players add @s[tag=!dragon] max_health 4`)
            entities[i].addTag('dragon')
            dimension.spawnItem(new ItemStack('edx:dragon_heart', 1), entities[i].location);
            dimension.spawnItem(new ItemStack('edx:dragon_essence', 1), entities[i].location);

        }
    }
    if (deadEntity.typeId === 'edx:true_wither') {
        const entityOptions = {
            location: position,
            families: [ "player" ],
            maxDistance: 50
        }
        const entities = dimension.getEntities(entityOptions);
        for (let i = 0; i < entities.length ; i++){
            entities[i].runCommand(`scoreboard players add @s[tag=!true_wither] max_health 4`)
            entities[i].addTag('true_wither')

        }
    }
    if (deadEntity.typeId === 'edx:blazeblade2') {
        const entityOptions = {
            location: position,
            families: [ "player" ],
            maxDistance: 50
        }
        const entities = dimension.getEntities(entityOptions);
        for (let i = 0; i < entities.length ; i++){
            dimension.spawnItem(new ItemStack('edx:blaze_blade', 1), entities[i].location);
            dimension.spawnItem(new ItemStack('edx:explosive_blaze_rod', 1), entities[i].location);
            entities[i].runCommand(`scoreboard players add @s[tag=!blazeblade] max_health 4`)
            entities[i].addTag('blazeblade')

        }
    }}
    catch(e){}
    

 
})