import { world,system,MolangVariableMap,TicksPerSecond,ItemStack} from "@minecraft/server"


function isFamily(family, entity) {
    try {
    entity.runCommand(`testfor @s[family=${family}]`)
    return true
    } catch { return false }
  }

function getKnockbackValue(itemUsed) {
    var value = 1
    if(itemUsed?.getComponent('enchantable')?.getEnchantment("knockback")?.level>0)
        value = itemUsed?.getComponent('enchantable')?.getEnchantment("knockback")?.level*1.25
    return value
}
function getScore(player, objective) {
    try {
      const s = world.scoreboard.getObjective(objective);
      if (!s) world.scoreboard.addObjective(objective, objective);
      return s.getScore(player.scoreboardIdentity)!=0?s.getScore(player.scoreboardIdentity):1;
    } catch {
      return 1;
    }
}
function getDamage(player,damage)
{
    if(player.hasTag('charged_hit_scroll'))
    {
        damage*=1.2
    }
    if(player.hasTag('chaining_scroll'))
    {
        damage*=(1+0.1*getScore(player,'Chaining'))
    }
    damage = Math.round(damage * 100) / 100 // 2 chiffres apres virgule 
    return damage
}

world.afterEvents.entityHurt.subscribe((ev) => {
    if(victim == undefined || attacker == undefined)
    var victim = ev.hurtEntity
    var damage = ev.damage
    var attacker = ev.damageSource.damagingEntity
    var projectile = ev.damageSource.damagingProjectile
    const dimension = victim.dimension

    if(victim.typeId == "edx:training_dummy")
    {
        victim.addEffect('regeneration', 5, { amplifier: 200, showParticles: false})
        victim.nameTag = Math.round(Math.round(damage * 100) / 100).toString()
        victim.triggerEvent('show')
        system.runTimeout(() => {
            victim.triggerEvent('stop_show')
            victim.nameTag =""
        }, TicksPerSecond);
    }

    if (projectile != undefined && attacker != undefined){
        if (projectile.typeId === 'edx:fire_strike') {
            victim.setOnFire(4, true);
        }
    }
    if(victim.typeId == "edx:gloopine")
        {
            if(victim.getComponent('variant')?.value==0)
            {
                victim.triggerEvent('go_fat')
            }
            else{
                dimension.spawnParticle('edx:gloopine_explode',victim.location)
                dimension.createExplosion(victim.location, 4, { breaksBlocks: false, causesFire: false })
                victim.runCommand(`loot spawn  ~~~ loot gloopine`)
                victim.remove()
            }
        }
        if(victim.typeId == "edx:gloop_ball")
            {
                if(victim.getComponent('variant')?.value==0)
                {
                    victim.triggerEvent('go_fat')
                }
                else{
                    dimension.spawnParticle('edx:gloopine_explode',victim.location)
                    dimension.createExplosion(victim.location, 4, { breaksBlocks: false, causesFire: false })
                    victim.remove()
                }
            }
    if (attacker != undefined){
        if (attacker.typeId === 'minecraft:player' && attacker.hasTag("explosive_blaze_rod") && victim.getComponent("minecraft:onfire")) {
            system.runTimeout(() => {
                var entities = victim.dimension.getEntities({
                    location: { x: victim.location.x, y: victim.location.y, z: victim.location.z },
                    maxDistance: 0.5,
                });
                victim.runCommand(`particle edx:blazeblade_explosion ~~1~`)
                for (let entity of entities) {
                    entity.applyDamage(5,{
                        cause: "fire" ,
                    },)
                    entity.applyKnockback(0,0,0,0.5);
                entity.extinguishFire()
                };
                
            },20)
        }
        
        //sword sweep attack
        else if(attacker?.typeId === 'minecraft:player' && attacker?.getComponent('equippable')?.getEquipment('Mainhand')?.hasTag('minecraft:is_sword'))
            {
                const player = attacker;
                if( getScore(player,'Hit_cooldown')<=1 && !player.isSprinting && player.isOnGround)
                    {
                        const itemUsed = player?.getComponent('equippable')?.getEquipment('Mainhand')
                        let fireAspectLevel = itemUsed?.getComponent('enchantable')?.getEnchantment("fire_aspect")?.level ?? 0
                        var entitiesCircle = world.getDimension(player.dimension.id).getEntities({
                            excludeTypes: ["minecraft:item"],
                            excludeFamilies:["projectile"],
                            location: victim.location,
                            maxDistance: 2,
                        });
                        entitiesCircle.forEach(entity=>
                            {
                                if(victim.typeId != "minecraft:player" || world.gameRules.pvp==true)
                                    if(victim!=entity && entity!=player && entity.typeId!="minecraft:xp_orb" && entity.typeId!="minecraft:item")
                                        {
                                            
                                            entity?.applyKnockback(player.getViewDirection().x, player.getViewDirection().z, Math.sqrt(player.getViewDirection().x ** 2 + player.getViewDirection().z ** 2)*getKnockbackValue(itemUsed), 0.5)
                                            entity.applyDamage(getDamage(player,damage)/3,{cause: "entityAttack"})
                                            entity.setOnFire(fireAspectLevel*4)
                                        }
                            }
                        )
                        const particleLocation = {x:player.getHeadLocation().x+player.getViewDirection().x ,y:player.getHeadLocation().y+player.getViewDirection().y-0.4 ,z:player.getHeadLocation().z+player.getViewDirection().z} 
                        world.getDimension(player.dimension.id).spawnParticle("edx:sweep_attack", particleLocation)
                        world.getDimension(player.dimension.id).playSound('vr.stutterturn', player.location);
                        if(player.hasTag('charged_hit_scroll'))
                        {
                            player.applyKnockback(-player.getViewDirection().x, -player.getViewDirection().z, Math.sqrt(player.getViewDirection().x ** 2 + player.getViewDirection().z ** 2)*2, 0.5)
                        }
                        if(player.hasTag('charged_hit_scroll') || player.hasTag('chaining_scroll'))
                            victim?.applyDamage(getDamage(player,damage),{cause: "entityAttack"})
                        if(player.hasTag('uppercut_scroll') && !victim.dimension.getBlock({x:victim.location.x,y:victim.location.y-0.5,z:victim.location.z}).isAir)
                        {
                            world.getDimension(victim.dimension.id).spawnParticle('edx:uppercut',victim.location);
                            victim.clearVelocity()
                            victim.applyKnockback(0, 0,0, 0.5)
                        }
                            
                    }
                    
                    if(player.hasTag('crushing_scroll') && victim.dimension.getBlock({x:victim.location.x,y:victim.location.y-0.5,z:victim.location.z}).isAir)
                        {
                            world.getDimension(victim.dimension.id).spawnParticle('edx:uppercut',victim.location);
                            victim?.applyKnockback(0, 0,0, -0.7)
                            victim.applyDamage(getDamage(player,damage)+2,{cause: "entityAttack"})
                        }
                    if(player.hasTag('chaining_scroll') && (isFamily('monster', victim) === true || isFamily('mob', victim) === true))
                    {
                        if(getScore(player,'Chaining')<6)
                        {
                            world.getDimension(victim.dimension.id).spawnParticle('edx:chaining_particle',victim.getHeadLocation());
                            player.runCommand(`scoreboard players add @s Chaining 1`)
                        }
                    }
                        player.runCommand(`scoreboard players set @s Hit_cooldown 20`)

                     
            }
            
            if(attacker?.typeId === 'minecraft:player')
            {
                
                
            }
        }
        if(victim.typeId === 'minecraft:player')
        {
            var player = victim
            if(getScore(player,'Chaining')>0)
            {
                const vmap = new MolangVariableMap();
                vmap.setFloat('variable.amount', getScore(victim,'Chaining'));
                world.getDimension(victim.dimension.id).spawnParticle('edx:chaining_hurt_particle',victim.getHeadLocation(),vmap);
                player.runCommand(`scoreboard players set @s Chaining 0`)
            }
        }


    

    
})

