import { world, system, BlockPermutation } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(eventData => {

    eventData.blockComponentRegistry.registerCustomComponent('soul_plant:on_destroy', {
        onPlayerDestroy: ({ block,dimension }) => {
            let random = Math.random() <= 1/6;
            if (random) {
                system.runTimeout(() => { 
                    dimension.spawnEntity("xp_orb",block.bottomCenter());
                     }
                 )
            }
         } 
    });
    
    eventData.blockComponentRegistry.registerCustomComponent('soul_torchflower:on_destroy', {
        onPlayerDestroy: ({ block,dimension }) => {
            let random = Math.random() <= 1/2;
            if (random) {
                system.runTimeout(() => { 
                    dimension.spawnEntity("xp_orb",block.bottomCenter());
                    dimension.spawnEntity("xp_orb",block.bottomCenter());
                    dimension.spawnEntity("xp_orb",block.bottomCenter());
                     }
                 )
            }
         } 
    });

    eventData.blockComponentRegistry.registerCustomComponent('soul_vines:on_destroy', {
        onPlayerDestroy: e => {
            const { block } = e;
            const {x,y,z} = block.location;
            var location = { x: e.block.location.x, y: e.block.location.y, z: e.block.location.z };
            system.runTimeout(() => { 
                e.dimension.runCommand(`fill ${location.x} ${location.y+1} ${location.z} ${location.x} ${location.y+1} ${location.z} edx:soul_vines_head replace edx:soul_vines`)
                 }
             )
             let random = Math.random() <= 1/6;
             if (random) {
                 system.runTimeout(() => { 
                     dimension.spawnEntity("xp_orb",block.bottomCenter());
                      }
                  )
             }
         } 
    }); 
    eventData.blockComponentRegistry.registerCustomComponent('soul_vines:on_place', {
        onPlace: e => {
            const { block } = e;
            const belowBlock = block.below();
            const {x,y,z} = block.location;
            var location = { x: e.block.location.x, y: e.block.location.y, z: e.block.location.z };
            if (belowBlock.typeId === 'minecraft:air') {
                system.runTimeout(() => { 
                    e.dimension.runCommand(`fill ${location.x} ${location.y} ${location.z} ${location.x} ${location.y} ${location.z} edx:soul_vines_head`)
                     }
                 )
            }
            system.runTimeout(() => { 
                e.dimension.runCommand(`fill ${location.x} ${location.y+1} ${location.z} ${location.x} ${location.y+1} ${location.z} edx:soul_vines replace edx:soul_vines_head`)
                 }
             )
        },
    }); 
eventData.blockComponentRegistry.registerCustomComponent('soul_vines:on_tick', {
    onRandomTick: e => {
        let randomTick = Math.random() <= 1/6;
            const { block } = e;
            const belowBlock = block.below();
            const {x,y,z} = block.location;
            var location = { x: e.block.location.x, y: e.block.location.y, z: e.block.location.z };
            if (randomTick && belowBlock.typeId === 'minecraft:air') {
                system.runTimeout(() => { 
                    e.dimension.runCommand(`fill ${location.x} ${location.y-1} ${location.z} ${location.x} ${location.y-1} ${location.z} edx:soul_vines_head`)
                    e.dimension.runCommand(`fill ${location.x} ${location.y} ${location.z} ${location.x} ${location.y} ${location.z} edx:soul_vines replace edx:soul_vines_head`)
                     }
                 )
            }
        },
    }); 
eventData.blockComponentRegistry.registerCustomComponent('edx:eye_tick', {
    onRandomTick({block}) {
        let randomTick = Math.random() <= 1/6;
        if(block.permutation?.getState('edx:stage')<2)
        { 
            if(randomTick )
                block.setPermutation(BlockPermutation.resolve(block.typeId).withState("edx:stage", block.permutation.getState("edx:stage")+1))
        }  
        else if(block.permutation?.getState('edx:stage')==2)
        { 
            let randomBlueEye =  Math.random() < 1/200
            if(randomTick &&  randomBlueEye) 
                block.setPermutation(BlockPermutation.resolve(block.typeId).withState("edx:stage", 4))
            else if(randomTick &&  !randomBlueEye)
                block.setPermutation(BlockPermutation.resolve(block.typeId).withState("edx:stage", 3))
        }  

    }
});
eventData.blockComponentRegistry.registerCustomComponent('edx:organic_vase_tick', {
    onRandomTick({block}) {
        let randomTick = Math.random() <= 1/5;
        if(block.permutation?.getState('edx:stage')<4)
        { 
            if(randomTick )
                block.setPermutation(BlockPermutation.resolve(block.typeId).withState("edx:stage", block.permutation.getState("edx:stage")+1))
        }
    }
});
eventData.blockComponentRegistry.registerCustomComponent('edx:organic_vase_destroy', {
    onPlayerDestroy: ({ block,dimension }) => {
            system.runTimeout(() => { 
                dimension.spawnEntity("xp_orb",block.bottomCenter());
                dimension.spawnEntity("xp_orb",block.bottomCenter());
                dimension.spawnEntity("xp_orb",block.bottomCenter());
                dimension.spawnEntity("xp_orb",block.bottomCenter());
                 }
             )
     } 
});
});